require 'minitest/autorun'
require 'calculate-tip'

class CalculateTipTest < Minitest::Test
  
  def setup
    @calc = CalculateTip.new("10", "5", "EUR")
    @params = GetParameters.new(["--аmount", "100", "eur", "--tip", "20"])
    @output_string = "Total amount with tip: 10.5 EUR
Tip amount: 0.5 EUR
Calculation with external API 
{\"amount\":10.0,\"tip\":0.5,\"amount_with_tip\":10.5}
"
  end

  def test_amount_is_float
    assert_equal 10.0, @calc.get_amount
  end

  def test_tip_is_float
    assert_equal 5.0, @calc.get_tip
  end

  def test_catch_exception_negative_amount
    exception = assert_raises(ArgumentError) { CalculateTip.new("-10", "5", nil) }
    assert_equal( "Amount is negative!", exception.message )
  end

  def test_calculate
    assert_output(@output_string) { @calc.calculate }
  end

  def test_default_tip
    args = @params.get_parameters
    calc_cl = CalculateTip.new(args[0])
    assert_equal 15.0, calc_cl.get_tip
  end

end